clear freq* S22*
close all
% load the old data
[freq1,S22db,S22Phase]=textread('cavitaS22.s1p','%f\t%f\t%f','headerlines',7);

% Get the real and the immaginary part
S22real=real(10.^(S22db/20).*exp(1i*(S22Phase/180*pi)));
S22imag=imag(10.^(S22db/20).*exp(1i*(S22Phase/180*pi)));

S22=S22real+1i.*S22imag;
figure
[lineseries,hsm] = smithchart(S22real+1i.*S22imag);
set(lineseries,'LineWidth',5,'Marker','+','MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],'MarkerSize',1);
set(hsm,'LineWidth',2,'LabelSize',18,'Color',[0 0 0]);
hold on;

% return
impedance=(1+S22)./(1-S22);
figure;
plot(freq1,20*log10(abs(impedance)))
xlabel('Frequency (GHz)')
ylabel('Impedance/Z_0 (dB)')

figure;
[f_res,Qunload,Qload,Qext,beta2]=qfactor(freq1,S22real,S22imag);
